## supple 1.0.7

=== Makefile ===
all: test

LMODULES := supple supple.request supple.objects supple.sandbox \
	    supple.host supple.comms supple.track
CMODULES := supple.capi
MODULES := $(LMODULES) $(CMODULES)
LUA_VER := 5.1

TEST_MODULES := $(MODULES)

PREFIX ?= /usr/local

INST_BASE := $(PREFIX)
WRAPPER_PATH := $(INST_BASE)/lib/supple-sandbox$(LUA_VER)

LINST_ROOT := $(DESTDIR)$(INST_BASE)/share/lua/$(LUA_VER)
CINST_ROOT := $(DESTDIR)$(INST_BASE)/lib/lua/$(LUA_VER)
BINST_ROOT := $(DESTDIR)$(INST_BASE)/lib
LMOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(LMODULES)))
CMOD_FILES := $(patsubst %,%.so,$(subst .,/,$(CMODULES)))

CMOD_TARGETS := $(patsubst %,lib/%.so,$(subst .,/,$(CMODULES)))
CMOD_OBJECTS := $(patsubst %,lib/%.o,$(subst .,/,$(CMODULES)))

.PRECIOUS: $(CMOD_OBJECTS)

LUA_INTERP_NAME := lua$(LUA_VER)
LUA_INTERP_PATH := $(shell which lua$(LUA_VER))

INCS := -I/usr/include/lua$(LUA_VER)
OPT := -O0 -g
WARN := -Wall -Werror
DEFS := -D'LUA_INTERP_NAME="$(LUA_INTERP_NAME)"' \
        -D'LUA_INTERP_PATH="$(LUA_INTERP_PATH)"' \
	-D'WRAPPER_PATH="$(WRAPPER_PATH)"'
CFLAGS := $(INCS) $(OPT) $(WARN) $(DEFS) $(CFLAGS)
LFLAGS := -O1 -g $(LFLAGS)

%.so: %.o
	$(CC) $(LFLAGS) -shared -o $@ $^ -llua$(LUA_VER)

%.o: %.c
	$(CC) $(CFLAGS) -fPIC -o $@ -c $<

build: $(CMOD_TARGETS) wrapper

wrapper: src/wrapper.c
	$(CC) $(LFLAGS) $(CFLAGS) -o $@ $< -llua$(LUA_VER)

testwrapper: src/wrapper.c
	$(CC) $(LFLAGS) $(CFLAGS) -DTESTING_SUPPLE -o $@ $< -llua$(LUA_VER)
	-chown root:root $@ && chmod u+s $@
	ls -l $@

COPY_LMOD := sed -e'/START_TEST_SUPPLE/,/END_TEST_SUPPLE/d'

install: build
	mkdir -p $(LINST_ROOT)/supple
	mkdir -p $(CINST_ROOT)/supple
	mkdir -p $(BINST_ROOT)
	cp wrapper $(DESTDIR)$(WRAPPER_PATH)
	chown root:root $(DESTDIR)$(WRAPPER_PATH)
	chmod u+s $(DESTDIR)$(WRAPPER_PATH)
	for MOD in $(sort $(LMOD_FILES)); do \
		$(COPY_LMOD) lib/$${MOD} > $(LINST_ROOT)/$${MOD}; \
	done
	for MOD in $(sort $(CMOD_FILES)); do \
		cp lib/$${MOD} $(CINST_ROOT)/$${MOD}; \
	done

ifeq ($(DEBUG),gdb)
GDB := gdb --args
endif

LUA := SUPPLE_TEST_WRAPPER="$(shell pwd)/testwrapper" LUA_PATH="$(shell pwd)/lib/?.lua;$(shell pwd)/extras/luacov/src/?.lua;;" LUA_CPATH="$(shell pwd)/lib/?.so;;" $(GDB) $(LUA_INTERP_PATH)

clean:
	$(RM) luacov.report.out luacov.stats.out
	$(RM) $(CMOD_TARGETS) $(CMOD_OBJECTS)
	$(RM) wrapper testwrapper
	$(RM) -r html

distclean: clean
	find . -name "*~" -delete

.PHONY: example
example:
	$(LUA) example/simple-example.lua

.PHONY: test
test: build testwrapper
	@$(RM) luacov.stats.out
	@ERR=0; \
	for MOD in $(sort $(TEST_MODULES)); do \
		echo -n "$${MOD}: "; \
		$(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(TEST_MODULES); \
	exit $$ERR

.PHONY: interactive
interactive: build
	$(LUA) -e'lace=require"supple"' -i

doc:
	@ldoc .

=== debian/changelog ===
supple (1.0.7-1) unstable; urgency=medium

  * New upstream release
  * Moves arch-specific bits from supple.host into supple.capi because
    Lua packaging doesn't support LUA_SOURCES_ARCHDEP properly yet.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 17 Oct 2016 12:49:16 +0900

supple (1.0.6-2) unstable; urgency=medium

  * Put supple.host into LUA_SOURCES_ARCHDEP to fix multiarch snafu
    since host.lua contains the path to the wrapper. (Closes: #840769)
  * Also handle putting it back into LUA_SOURCES for the duration of
    test because the copy doesn't handle them yet.
  * Use SOURCE_DATE_EPOCH in ldoc invocation to improve reproducibility.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 15 Oct 2016 11:25:35 +0900

supple (1.0.6-1) unstable; urgency=medium

  * New upstream release with extra GC protection (Closes: #840703)
  * Limit lua-supple to linux-any because of issues with socketpair()
    (and a lack of seccomp mode) on kfreebsd and hurd. (Closes: #840704)

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 14 Oct 2016 16:40:43 +0900

supple (1.0.5-1) unstable; urgency=medium

  * Initial packaging of Supple as a separate project.
  * Closes: #840611

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 13 Oct 2016 20:31:29 +0900

## supple 1.0.8

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,7 @@
 BINST_ROOT := $(DESTDIR)$(INST_BASE)/lib
 LMOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(LMODULES)))
 CMOD_FILES := $(patsubst %,%.so,$(subst .,/,$(CMODULES)))
+LIB_LUA := -llua$(LUA_VER)
 
 CMOD_TARGETS := $(patsubst %,lib/%.so,$(subst .,/,$(CMODULES)))
 CMOD_OBJECTS := $(patsubst %,lib/%.o,$(subst .,/,$(CMODULES)))
@@ -27,17 +28,33 @@
 LUA_INTERP_NAME := lua$(LUA_VER)
 LUA_INTERP_PATH := $(shell which lua$(LUA_VER))
 
+# Override these variables
+# to bake LUA_PATH and LUA_CPATH environment variables into the sandbox binary.
+# They can't be set at runtime for security reasons.
+BAKE_SUPPLE_PATHS := 0
+SUPPLE_LUA_PATH :=
+SUPPLE_LUA_CPATH :=
+
+ifeq ($(BAKE_SUPPLE_PATHS), 1)
+	DEF_BAKE_SUPPLE_PATHS=-DBAKE_SUPPLE_PATHS
+else
+	DEF_BAKE_SUPPLE_PATHS=
+endif
+
 INCS := -I/usr/include/lua$(LUA_VER)
 OPT := -O0 -g
 WARN := -Wall -Werror
 DEFS := -D'LUA_INTERP_NAME="$(LUA_INTERP_NAME)"' \
         -D'LUA_INTERP_PATH="$(LUA_INTERP_PATH)"' \
-	-D'WRAPPER_PATH="$(WRAPPER_PATH)"'
+	-D'SUPPLE_LUA_PATH="$(SUPPLE_LUA_PATH)"' \
+	-D'SUPPLE_LUA_CPATH="$(SUPPLE_LUA_CPATH)"' \
+	-D'WRAPPER_PATH="$(WRAPPER_PATH)"' $(DEF_BAKE_SUPPLE_PATHS)
+
 CFLAGS := $(INCS) $(OPT) $(WARN) $(DEFS) $(CFLAGS)
 LFLAGS := -O1 -g $(LFLAGS)
 
 %.so: %.o
-	$(CC) $(LFLAGS) -shared -o $@ $^ -llua$(LUA_VER)
+	$(CC) $(LFLAGS) -shared -o $@ $^
 
 %.o: %.c
 	$(CC) $(CFLAGS) -fPIC -o $@ -c $<
@@ -45,10 +62,10 @@
 build: $(CMOD_TARGETS) wrapper
 
 wrapper: src/wrapper.c
-	$(CC) $(LFLAGS) $(CFLAGS) -o $@ $< -llua$(LUA_VER)
+	$(CC) $(LFLAGS) $(CFLAGS) -o $@ $< $(LIB_LUA)
 
 testwrapper: src/wrapper.c
-	$(CC) $(LFLAGS) $(CFLAGS) -DTESTING_SUPPLE -o $@ $< -llua$(LUA_VER)
+	$(CC) $(LFLAGS) $(CFLAGS) -DTESTING_SUPPLE -o $@ $< $(LIB_LUA)
 	-chown root:root $@ && chmod u+s $@
 	ls -l $@
 
@@ -59,8 +76,10 @@
 	mkdir -p $(CINST_ROOT)/supple
 	mkdir -p $(BINST_ROOT)
 	cp wrapper $(DESTDIR)$(WRAPPER_PATH)
-	chown root:root $(DESTDIR)$(WRAPPER_PATH)
-	chmod u+s $(DESTDIR)$(WRAPPER_PATH)
+	if [ "$$(whoami)" = "root" ]; then \
+		chown root:root $(DESTDIR)$(WRAPPER_PATH); \
+		chmod u+s $(DESTDIR)$(WRAPPER_PATH); \
+	fi
 	for MOD in $(sort $(LMOD_FILES)); do \
 		$(COPY_LMOD) lib/$${MOD} > $(LINST_ROOT)/$${MOD}; \
 	done
@@ -77,7 +96,7 @@
 clean:
 	$(RM) luacov.report.out luacov.stats.out
 	$(RM) $(CMOD_TARGETS) $(CMOD_OBJECTS)
-	$(RM) wrapper testwrapper
+	$(RM) wrapper testwrapper supple_paths.h
 	$(RM) -r html
 
 distclean: clean

=== debian/changelog ===
supple (1.0.8-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 02 Aug 2017 18:03:20 -0400

=== debian/control ===
Source: supple
Section: interpreters
Priority: optional
Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), dh-lua, lua-ldoc, lua-discount,
  lua-luxio
Standards-Version: 3.9.8
Homepage: https://www.gitano.org.uk/supple/

Package: lua-supple
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, lua-luxio0
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Multi-Arch: same
Description: Lua strict sandbox
 Supple is a very strict sandbox which runs Lua code on behalf of applications
 which cannot trust the code very much.
 .
 Supple relies on a number of techniques to sandbox the user code away from the
 host application, such as chroots, seccomp mode, interpreter sandboxing, and
 rlimits.

Package: lua-supple-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for lua-supple
 Supple is a very strict sandbox which runs Lua code on behalf of applications
 which cannot trust the code very much.
 .
 Supple relies on a number of techniques to sandbox the user code away from the
 host application, such as chroots, seccomp mode, interpreter sandboxing, and
 rlimits.
 .
 This package contains the documentation on how to use the Supple library.

=== debian/watch ===
version=3
https://git.gitano.org.uk/supple.git /supple\.git/snapshot/supple-(.+)\.tar.bz2
